/*
   g_ncp.c A graphical userinterface to ncpmount and ncpumount

   Copyright (C) 1998 Stefan Heimers sheimers@ezinfo.vmsmail.ethz.ch
   http://www.datanetworks.ch/~sheimers/soft.html

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


   To compile you need the GTK+ toolkit ( http://www.gtk.org ) and ncpfs. I am using
   ftp://sunsite.cnlab-switch.ch/mirror/linux/distributions/redhat/redhat-5.0/updates/i386/ncpfs-2.0.11-3.i386.rpm
*/

#include <gtk/gtk.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include "g_ncp.h"
#include "menu.h"



gchar *login,*passwd,*servername;

/* this is a callback function. the data arguments are ignored in this example..
   * More on callbacks below. */

void hello (GtkWidget *widget, ...)
{
   g_print (login);

}



void destroy (GtkWidget *widget, gpointer data)
{
   gtk_main_quit ();
}

void get_login(GtkWidget *anywidget,gpointer data)
{
   login = gtk_entry_get_text((GtkEntry*) anywidget);
}

void getpasswd(GtkWidget *anywidget,gpointer data)
{
   passwd = gtk_entry_get_text((GtkEntry*) anywidget);
}

void getservername(GtkWidget *anywidget,gpointer data)
{
   servername = gtk_entry_get_text((GtkEntry*) anywidget);
}

void novell_disconnect(GtkWidget *anywidget,gpointer data)
{
 int file_handler;
   char *disconnect_cmd,*tmp_msg;
   disconnect_cmd=malloc(1000);
   sprintf(disconnect_cmd,"ncpumount %s/n_mount > /tmp/g_ncp.log 2>&1",getenv("HOME"));
   system(disconnect_cmd);
   gtk_text_insert (GTK_TEXT (logtext), font_strong, NULL, NULL,disconnect_cmd, -1);
   file_handler=open("/tmp/g_ncp.log", O_RDONLY);
   tmp_msg=malloc(1000);
   read(file_handler, tmp_msg, 1000);
   gtk_text_insert (GTK_TEXT (logtext),font_strong, NULL, NULL,tmp_msg, -1);
   close(file_handler);
   gtk_text_insert (GTK_TEXT (logtext),font_strong, NULL, NULL,"\n", -1);
   
   
   
}

void novell_connect(GtkWidget *anywidget,gpointer data)
{
   int file_handler;
   char *homedir,*mkdir_command=malloc(1000),*mountcommand=malloc(1000),*filemgrcmd=malloc(1000),*tmp_msg;
   homedir = getenv("HOME");
   sprintf(mkdir_command,"mkdir ");
   strcat(mkdir_command,homedir);
   strcat(mkdir_command,"/n_mount >/tmp/g_ncp.log 2>&1");
   g_print(mkdir_command);
   system(mkdir_command);
   system("chmod og-r+w /tmp/g_ncp.log");
   gtk_text_insert (GTK_TEXT (logtext), font_strong, NULL, NULL,mkdir_command, -1);
   file_handler=open("/tmp/g_ncp.log", O_RDONLY);
   tmp_msg=malloc(1000);
   read(file_handler, tmp_msg, 1000);
   gtk_text_insert (GTK_TEXT (logtext),font_strong, NULL, NULL,tmp_msg, -1);
   close(file_handler);
   gtk_text_insert (GTK_TEXT (logtext),font_strong, NULL, NULL,"\n", -1);

   gtk_text_insert (GTK_TEXT (logtext),font_strong, NULL, NULL,
      mkdir_command, -1);
   gtk_text_insert (GTK_TEXT (logtext),font_strong, NULL, NULL,"\n", -1);

   sprintf(mountcommand,"ncpmount -S %s  %s/n_mount -U %s -P %s -u %s -g users > /tmp/g_ncp.log 2>&1",servername,
      homedir,login,passwd, getenv("USER"));


   g_print(mountcommand);
   system(mountcommand);
   gtk_text_insert (GTK_TEXT (logtext), font_strong, NULL, NULL,mountcommand, -1);
   file_handler=open("/tmp/g_ncp.log", O_RDONLY);
   tmp_msg=malloc(1000);
   read(file_handler, tmp_msg, 1000);
   gtk_text_insert (GTK_TEXT (logtext),font_strong, NULL, NULL,tmp_msg, -1);
   close(file_handler);
   system("rm /tmp/g_ncp.log");
   gtk_text_insert (GTK_TEXT (logtext),font_strong, NULL, NULL,"\n", -1);

   sprintf(filemgrcmd,WHICH_FILEMANAGER);
   sprintf(filemgrcmd,"%s file:%s/n_mount",filemgrcmd,homedir);
   g_print(filemgrcmd);
   system(filemgrcmd);
   gtk_text_insert (GTK_TEXT (logtext), font_strong, NULL, NULL,
      filemgrcmd, -1);
   gtk_text_insert (GTK_TEXT (logtext),font_strong, NULL, NULL,"\n\n", -1);

}


gint delete_event(GtkWidget *widget, gpointer data)
{
   char disconnect_cmd[1000];
   sprintf(disconnect_cmd,"ncpumount %s/n_mount",getenv("HOME"));
   system(disconnect_cmd);
   return (FALSE);
}

GtkWidget *logwindow(GtkWidget *local_vbox)
{


   GtkAdjustment *vadj;

  
   vadj = GTK_ADJUSTMENT (gtk_adjustment_new (0.0, 0.0, 0.0, 0.0, 0.0, 0.0));
   logtext = gtk_text_new (NULL, vadj);
   gtk_text_set_editable (GTK_TEXT (logtext), FALSE);
   gtk_widget_set_usize (logtext, 400, 300);

   gtk_container_add (GTK_CONTAINER (local_vbox),logtext);


   font_strong = gdk_font_load ("-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*");
   font_emphasis = gdk_font_load ("-*-helvetica-medium-o-normal-*-*-100-*-*-*-*-*-*");
   font = gdk_font_load ("-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*");

/*  Realize the widget before allowing new text to be inserted  */
   gtk_widget_realize (logtext);

   gtk_text_insert (GTK_TEXT (logtext), font_strong, NULL, NULL,
      "Commands executed and error messages:\n\n", -1);
 
//   gtk_widget_show (logtext); 
return logtext;
}

int main (int argc, char *argv[])
{
   char config_file[1000];

   GtkWidget *main_vbox,*buttons_hbox,*entry_hbox,*entry_label;
   GtkWidget *button,*server_entry,*login_entry,*passwd_entry;
   GtkWidget *menubar;
   GtkAcceleratorTable *accel;

   strcat(config_file,getenv("HOME")); /*free Mem of getenv(HOME)?*/
   strcat(config_file,GNOVELLRC);
   servername=malloc(strlen(DEFAULT_SERVER));
   sprintf(servername,DEFAULT_SERVER);
   login=getenv("USER");
   gtk_init (&argc, &argv);

   font_strong = gdk_font_load ("-*-helvetica-bold-r-normal-*-*-120-*-*-*-*-*-*");
   font_emphasis = gdk_font_load ("-*-helvetica-medium-o-normal-*-*-100-*-*-*-*-*-*");
   font = gdk_font_load ("-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*");


/* create a new window */
   window = gtk_window_new (GTK_WINDOW_TOPLEVEL);


   gtk_signal_connect (GTK_OBJECT (window), "delete_event",
      GTK_SIGNAL_FUNC (delete_event), NULL);

/* here we connect the "destroy" event to a signal handler.
      * This event occurs when we call gtk_widget_destroy() on the window,
      * or if we return 'FALSE' in the "delete_event" callback. */
   gtk_signal_connect (GTK_OBJECT (window), "destroy",
      GTK_SIGNAL_FUNC (destroy), NULL);
/*gtk_container_border_width (GTK_CONTAINER (window), 10);*/

   main_vbox = gtk_vbox_new (FALSE,0);/*gtk_vbox_new(homogenous,spacing)*/
   gtk_container_add (GTK_CONTAINER (window), main_vbox);

/*Menu*/
   get_main_menu(&menubar, &accel);
   gtk_window_add_accelerator_table(GTK_WINDOW(window), accel);
   gtk_box_pack_start(GTK_BOX(main_vbox), menubar, FALSE, TRUE, 0);
   gtk_widget_show(menubar);


/*login entry label and field*/
   entry_hbox = gtk_hbox_new (FALSE,0);
   entry_label=gtk_label_new (LOGIN_QUESTION );
   gtk_widget_set_usize (entry_label, 200, 20); 
   gtk_widget_show(entry_label);
   gtk_container_add (GTK_CONTAINER (entry_hbox),(GtkWidget*)entry_label);
   login_entry = gtk_entry_new();
   gtk_widget_set_usize (login_entry, 200, 20);
   gtk_entry_set_text(GTK_ENTRY (login_entry),getenv("USER"));
   gtk_signal_connect(GTK_OBJECT (login_entry), "changed",
      GTK_SIGNAL_FUNC (get_login), NULL);
   gtk_container_add (GTK_CONTAINER (entry_hbox),(GtkWidget*)login_entry);
   gtk_widget_show(entry_hbox);
 gtk_box_pack_start (GTK_BOX (main_vbox), entry_hbox, FALSE, FALSE, 0);


/*password entry label and field*/
   entry_hbox = gtk_hbox_new (FALSE,0);
   entry_label=gtk_label_new (PASSWD_QUESTION);
   gtk_widget_set_usize (entry_label, 200, 20);
   gtk_widget_show(entry_label);
   gtk_container_add (GTK_CONTAINER (entry_hbox),(GtkWidget*)entry_label);
   passwd_entry = gtk_entry_new();
   gtk_widget_set_usize (passwd_entry, 200, 20);
   gtk_entry_set_visibility (GTK_ENTRY(passwd_entry),FALSE);
   gtk_entry_set_text(GTK_ENTRY (passwd_entry),"");
   gtk_signal_connect(GTK_OBJECT (passwd_entry), "changed",
      GTK_SIGNAL_FUNC (getpasswd), NULL);
   gtk_container_add (GTK_CONTAINER (entry_hbox), passwd_entry);
   gtk_widget_show(entry_hbox);
   //gtk_container_add (GTK_CONTAINER (main_vbox), (GtkWidget*)entry_hbox);
   gtk_box_pack_start (GTK_BOX (main_vbox), entry_hbox, FALSE, FALSE, 0);


/*server entry label and field*/
   entry_hbox = gtk_hbox_new (TRUE,0);
   entry_label=gtk_label_new (SERVER_QUESTION);
   gtk_widget_set_usize (entry_label, 200, 20);
   gtk_widget_show(entry_label);
   gtk_container_add (GTK_CONTAINER (entry_hbox),(GtkWidget*)entry_label);
   server_entry = gtk_entry_new();
   gtk_widget_set_usize (server_entry, 200, 20);
   gtk_entry_set_text(GTK_ENTRY(server_entry),DEFAULT_SERVER);
   gtk_signal_connect(GTK_OBJECT (server_entry), "changed",
      GTK_SIGNAL_FUNC (getservername), NULL);
   gtk_container_add (GTK_CONTAINER (entry_hbox), server_entry);
   gtk_widget_show(entry_hbox);
   //gtk_container_add (GTK_CONTAINER (main_vbox), (GtkWidget*)entry_hbox);
gtk_box_pack_start (GTK_BOX (main_vbox), entry_hbox, FALSE, FALSE, 0);
/*box for connect and disconnect buttons*/
   buttons_hbox=gtk_hbox_new(TRUE,0);

/*connect button*/
   button = gtk_button_new_with_label (CONNECT_LABEL);
   gtk_signal_connect (GTK_OBJECT (button), "clicked",
      GTK_SIGNAL_FUNC (novell_connect), (gpointer) login_entry);
   gtk_widget_show (button);
   gtk_container_add (GTK_CONTAINER (buttons_hbox), button);

/*disconnect button*/
   button = gtk_button_new_with_label (DISCONNECT_LABEL);
   gtk_signal_connect (GTK_OBJECT (button), "clicked",
      GTK_SIGNAL_FUNC (novell_disconnect), (gpointer) NULL);
   gtk_widget_show (button);
   gtk_container_add (GTK_CONTAINER (buttons_hbox), button);

  // gtk_container_add (GTK_CONTAINER (main_vbox),buttons_hbox);
   gtk_box_pack_start (GTK_BOX (main_vbox), buttons_hbox, FALSE, FALSE, 0);


   global_log=logwindow(main_vbox);
   
   //gtk_container_add (GTK_CONTAINER (main_vbox),g_log);

   gtk_widget_show (buttons_hbox);
   gtk_widget_show (server_entry);
   gtk_widget_show (main_vbox);
   gtk_widget_show (login_entry);
   gtk_widget_show (passwd_entry);
   gtk_widget_show (window);

   gtk_main ();

   return 0;
}








